package com.ynet.life.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.life.base.LifeAction;
import com.ynet.life.base.Trace;
import com.ynet.life.format.LifeFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class GetDateTimeAction extends LifeAction {

   private String timeFieldName;
   private String timeFormat;
   private int dateOffset = 0;
   private int timeOffset = 0;
   private int monthOffset = 0;
   private int yearOffset = 0;


   public String execute(Context context) throws GENEException {
      try {
         String empe;
         GregorianCalendar calendar;
         if(this.yearOffset != 0) {
            empe = this.timeFormat == null?"yyyyMMddHHmmss":this.timeFormat;
            (calendar = (GregorianCalendar)Calendar.getInstance()).add(1, this.yearOffset);
            empe = (new SimpleDateFormat(empe)).format(calendar.getTime());
            context.setDataValue(this.timeFieldName, empe);
         } else if(this.monthOffset != 0) {
            empe = this.timeFormat == null?"yyyyMMddHHmmss":this.timeFormat;
            (calendar = (GregorianCalendar)Calendar.getInstance()).add(2, this.monthOffset);
            empe = (new SimpleDateFormat(empe)).format(calendar.getTime());
            context.setDataValue(this.timeFieldName, empe);
         } else {
            empe = LifeFormat.getDifferentTime(24 * this.dateOffset, 0, this.timeOffset, this.timeFormat);
            context.setDataValue(this.timeFieldName, empe);
         }

         return "0";
      } catch (GENEException var4) {
         Trace.logError("LifeAction", var4.getMessage(), var4);
         throw var4;
      }
   }

   public static void main(String[] a) {
      GetDateTimeAction a1 = new GetDateTimeAction();
      Context c = new Context();
      a1.yearOffset = -1;
      a1.timeFormat = "yyyy";

      try {
         a1.execute(c);
      } catch (Exception var2) {
         var2.printStackTrace();
      }
   }

   public void setTimeFieldName(String name) {
      this.timeFieldName = name;
   }

   public void setTimeFormat(String format) {
      this.timeFormat = format == null?"yyyy-MM-dd HH:mm:ss":format;
   }

   public void setDateOffset(int dateOffset) {
      this.dateOffset = dateOffset;
   }

   public void setTimeOffset(int timeOffset) {
      this.timeOffset = timeOffset;
   }

   public void setMonthOffset(int monthOffset) {
      this.monthOffset = monthOffset;
   }

   public void setYearOffset(int yearOffset) {
      this.yearOffset = yearOffset;
   }
}
